Unit ASG9R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, AFG5R_p, UTAFSI_p;

procedure ASG9R(var A :Array of Real; M :Integer; N :Integer;
                var NLEAD :Array of Integer; var B :Array of Real;
                LTR :Integer; L :Integer; var IERR :Integer);

implementation

procedure ASG9R(var A :Array of Real; M :Integer; N :Integer;
                var NLEAD :Array of Integer; var B :Array of Real;
                LTR :Integer; L :Integer; var IERR :Integer);
var
I,J,JJ,K,KB,KP1,NM1 :Integer;
S,T :Real;
label
_10,_20,_30,_40,_50,_60,_70,_80,_90,_100,_110,_120,_130,_140,_150,
_160,_170,_180,_190,_200,_210,_220,_230,_240,_250,_260,_270,_280,_290,
_300,_310,_320,_330;
begin
{ ***************************************************C }
{   PEEHE CCTEM A*X=B  TRANS(A)*X=B METOOM   C }
{   AYCCA C BOPOM BEYEO EMEHA O CTOY     C }
{    MATP A OEO BA.                       C }
{ ***************************************************C }

{   YCTAHOBEHE KOHTPO HA BOMOHOCT EPEOHEH }
S  := 0.0;
_10:

{   POBEPKA PABHOCT AAH APAMETPOB M  N }
if ( N  >=  1 ) and (  M  >=  1 ) 
 then goto _20;
IERR  := 65;
UTAFSI('A','S','G','9','R',IERR);
goto _330;
_20:
IERR  := 0;
NM1  := N - 1;
if ( L  <>  0 ) 
 then goto _30;
AFG5R(A,M,N,NLEAD,IERR);
if ( IERR  <>  0 ) 
 then UTAFSI('A','S','G','9','R',IERR);
if ( IERR  <=  0 ) 
 then goto _30;
goto _330;
_30:
if ( LTR  <>  0 ) 
 then goto _190;

{   PEEHE CCTEM L*Y=B }
if ( NM1  <  1 ) 
 then goto _100;
for K:=1 to NM1 do
 begin
  JJ  := NLEAD[K-1];
  T  := B[JJ-1];
  if ( JJ  =  K ) 
   then goto _40;
  B[JJ-1] := B[K-1];
  B[K-1] := T;
_40:
  JJ  := N - K;
  I  := ((JJ) Mod (4)) + K;
  if ( I  =  K ) 
   then goto _60;
  KP1  := K + 1;
  for JJ:=KP1 to I do
   begin
    B[JJ-1] := B[JJ-1] + T*A[(JJ-1)+(K-1)*M];
_50:
   end;
_60:
  I  := I + 1;
  if ( I  >  N ) 
   then goto _80;
  JJ := I;
  while ( JJ<=N ) do
   begin
    B[JJ-1] := B[JJ-1] + T*A[(JJ-1)+(K-1)*M];
    B[JJ+0] := B[JJ+0] + T*A[(JJ+0)+(K-1)*M];
    B[JJ+1] := B[JJ+1] + T*A[(JJ+1)+(K-1)*M];
    B[JJ+2] := B[JJ+2] + T*A[(JJ+2)+(K-1)*M];
_70:
    inc(JJ,4);
   end;
_80:
_90:
 end;
_100:

{   PEEHE CCTEM U*X=Y }
for KB:=1 to N do
 begin
  K  := N + 1 - KB;
  if ( A[(K-1)+(K-1)*M] <>  0.0 ) 
   then goto _120;
  if ( B[K-1] <>  0.0 ) 
   then goto _110;
  B[K-1] := 1.0;
  goto _130;
_110:
  IERR  := 67;
  UTAFSI('A','S','G','9','R',IERR);
  goto _330;
_120:
  B[K-1] := B[K-1]/A[(K-1)+(K-1)*M];
_130:
  T  := B[K-1];
  J  := K - 1;
  I  := ((J) Mod (4));
  if ( I  =  0 ) 
   then goto _150;
  for JJ:=1 to I do
   begin
    B[JJ-1] := B[JJ-1] - T*A[(JJ-1)+(K-1)*M];
_140:
   end;
_150:
  I  := I + 1;
  if ( I  >  J ) 
   then goto _170;
  JJ := I;
  while ( JJ<=J ) do
   begin
    B[JJ-1] := B[JJ-1] - T*A[(JJ-1)+(K-1)*M];
    B[JJ+0] := B[JJ+0] - T*A[(JJ+0)+(K-1)*M];
    B[JJ+1] := B[JJ+1] - T*A[(JJ+1)+(K-1)*M];
    B[JJ+2] := B[JJ+2] - T*A[(JJ+2)+(K-1)*M];
_160:
    inc(JJ,4);
   end;
_170:
_180:
 end;
goto _330;

{   PEEHE CCTEM TRANS(U)*Y=B }
_190:
for K:=1 to N do
 begin
  T  := 0.0;
  J  := K - 1;
  I  := ((J) Mod (5));
  if ( I  =  0 ) 
   then goto _210;
  for JJ:=1 to I do
   begin
    T  := T + A[(JJ-1)+(K-1)*M]*B[JJ-1];
_200:
   end;
_210:
  I  := I + 1;
  if ( I  >  J ) 
   then goto _230;
  JJ := I;
  while ( JJ<=J ) do
   begin
    T  := T + A[(JJ-1)+(K-1)*M]*B[JJ-1] + A[(JJ+0)+(K-1)*M]*B[JJ+0] + A[(JJ+2-1)+(
    K-1)*M]*B[JJ+1] + A[(JJ+2)+(K-1)*M]*B[JJ+2] + A[(JJ+3)+(K-1)*M]*
    B[JJ+3];
_220:
    inc(JJ,5);
   end;
_230:
  if ( A[(K-1)+(K-1)*M] <>  0.0 ) 
   then goto _250;
  if ( B[K-1] - T  <>  0.0 ) 
   then goto _240;
  B[K-1] := 1.0;
  goto _260;
_240:
  IERR  := 67;
  UTAFSI('A','S','G','9','R',IERR);
  goto _330;
_250:
  B[K-1] := (B[K-1] - T)/A[(K-1)+(K-1)*M];
_260:
 end;

{   PEEHE CCTEM TRANS(L)*X=Y }
if ( NM1  <  1 ) 
 then goto _330;
for KB:=1 to NM1 do
 begin
  K  := N - KB;
  JJ  := N - K;
  I  := ((JJ) Mod (5)) + K;
  if ( I  =  K ) 
   then goto _280;
  KP1  := K + 1;
  for JJ:=KP1 to I do
   begin
    B[K-1] := B[K-1] + A[(JJ-1)+(K-1)*M]*B[JJ-1];
_270:
   end;
_280:
  I  := I + 1;
  if ( I  >  N ) 
   then goto _300;
  JJ := I;
  while ( JJ<=N ) do
   begin
    B[K-1] := B[K-1] + A[(JJ-1)+(K-1)*M]*B[JJ-1] + A[(JJ+0)+(K-1)*M]*B[JJ+0]
    + A[(JJ+1)+(K-1)*M]*B[JJ+1] + A[(JJ+2)+(K-1)*M]*B[JJ+2]
    + A[(JJ+3)+(K-1)*M]*B[JJ+3];
_290:
    inc(JJ,5);
   end;
_300:
  JJ  := NLEAD[K-1];
  if ( JJ  =  K ) 
   then goto _310;
  T  := B[JJ-1];
  B[JJ-1] := B[K-1];
  B[K-1] := T;
_310:
_320:
 end;
_330:
end;

end.
